﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace 抽稀
{

    public class PointViewModel : INotifyPropertyChanged
    {
        public PointViewModel()
        {
            Tolerance1 = Tolerance2 = 100;
        }
        public List<Point> Read
        {
            get
            {

                var fs = File.OpenRead(AppDomain.CurrentDomain.BaseDirectory + @"\600001 (1).csv");
                string sw;
                using (StreamReader sr = new StreamReader(fs))
                {
                    sw = sr.ReadToEnd();
                }
                fs.Close();
                var gp = sw.Split('\r');
                List<Point> points = new List<Point>();
                int count = 0;
                foreach (var item in gp)
                {
                    count++;
                    var hg = item.Split(',');
                    if (hg.Count() > 1)
                    {
                        var g = double.Parse(hg[1]);
                        if (g > 0)
                        {
                            //放大100
                            points.Add(new Point(count, g * 100));
                        }

                    }

                }
                return points;
            }
        }

        private int _Tolerance1;

        public int Tolerance1
        {
            get { return _Tolerance1; }
            set
            {
                _Tolerance1 = value;
                DP = Point_Algorithm.Douglas_Peucker.DouglasPeuckerReduction(this.Read, Tolerance1);
                Changed(nameof(DP));
                Changed();
            }
        }
        private int _Tolerance2;

        public event PropertyChangedEventHandler PropertyChanged;

        public void Changed([CallerMemberName] string name = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(name));
        }

        public int Tolerance2
        {
            get { return _Tolerance2; }
            set
            {
                _Tolerance2 = value;
                SIP = Point_Algorithm.SIP.BSIP(this.Read, Tolerance2);
                Changed(nameof(SIP));
                Changed();
            }
        }


        public List<Point> DP
        {
            get;
            set;
        }



        public List<Point> SIP
        {
            get;
            set;
        }

    }
}
